package demo.linecharts ;

import java.awt.BorderLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class LineChartDemo2 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public LineChartDemo2() {
    setLayout(new BorderLayout()) ;
    addPanel1() ;
  }

  private void addPanel1() {
    DefaultMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart("Line Chart Demo 2", "X", "Y", dataset,
                                                           orientation, true, true, false, false) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYLineAndShapeRender render = (XYLineAndShapeRender) plot.getRender() ;
    render.setBaseItemShapeVisible(true) ;
    render.setBaseItemShapeFilled(true) ;

    XYNumberValueAxis domainaxis = (XYNumberValueAxis) plot.getDomainAxis() ;
    domainaxis.setTickUnit(new LongTickUnit()) ;
    domainaxis.setLowerMargin(0.02) ;
    domainaxis.setUpperMargin(0.02) ;

    XYNumberValueAxis numberaxis = (XYNumberValueAxis) plot.getValueAxis() ;
    numberaxis.setTickUnit(new LongTickUnit()) ;
    numberaxis.setUpperMargin(0.02) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static DefaultMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("First") ;
    dataset.addRowKey("Second") ;
    dataset.addRowKey("Third") ;
    dataset.addRowData(3) ;

    dataset.addData(0, new XYNumberChartData(1.0D, 1.0D)) ;
    dataset.addData(0, new XYNumberChartData(2D, 4D)) ;
    dataset.addData(0, new XYNumberChartData(3D, 3D)) ;
    dataset.addData(0, new XYNumberChartData(4D, 5D)) ;
    dataset.addData(0, new XYNumberChartData(5D, 5D)) ;
    dataset.addData(0, new XYNumberChartData(6D, 7D)) ;
    dataset.addData(0, new XYNumberChartData(7D, 7D)) ;
    dataset.addData(0, new XYNumberChartData(8D, 8D)) ;

    dataset.addData(1, new XYNumberChartData(1.0D, 5D)) ;
    dataset.addData(1, new XYNumberChartData(2D, 7D)) ;
    dataset.addData(1, new XYNumberChartData(3D, 6D)) ;
    dataset.addData(1, new XYNumberChartData(4D, 8D)) ;
    dataset.addData(1, new XYNumberChartData(5D, 4D)) ;
    dataset.addData(1, new XYNumberChartData(6D, 4D)) ;
    dataset.addData(1, new XYNumberChartData(7D, 2D)) ;
    dataset.addData(1, new XYNumberChartData(8D, 1.0D)) ;

    dataset.addData(2, new XYNumberChartData(3D, 4D)) ;
    dataset.addData(2, new XYNumberChartData(4D, 3D)) ;
    dataset.addData(2, new XYNumberChartData(5D, 2D)) ;
    dataset.addData(2, new XYNumberChartData(6D, 3D)) ;
    dataset.addData(2, new XYNumberChartData(7D, 6D)) ;
    dataset.addData(2, new XYNumberChartData(8D, 3D)) ;
    dataset.addData(2, new XYNumberChartData(9D, 4D)) ;
    dataset.addData(2, new XYNumberChartData(10D, 3D)) ;

    return dataset ;
  }

}
