package demo.linecharts ;

import java.awt.BorderLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.tickunit.LongTickUnit ;
/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class LineChartDemo3 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public LineChartDemo3() {
    setLayout(new BorderLayout()) ;
    addPanel1() ;
  }

  private void addPanel1() {
    DefaultMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart("Line Chart Demo 3", "X", "Y", dataset,
                                                   orientation, true, true, false, false) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
    XYLineAndShapeRender render = (XYLineAndShapeRender) plot.getRender() ;
    render.setBaseItemShapeVisible(true) ;
    render.setBaseItemShapeFilled(true) ;

    XYNumberValueAxis domainaxis = (XYNumberValueAxis) plot.getDomainAxis() ;
    domainaxis.setUpperMargin(0.02) ;

    XYNumberValueAxis numberaxis = (XYNumberValueAxis) plot.getValueAxis() ;
    numberaxis.setTickUnit(new LongTickUnit()) ;
    numberaxis.setUpperMargin(0.02) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static DefaultMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;

    for (int i = 0 ; i < 10 ; i++) {
      dataset.addRowKey("S" + i) ;
      dataset.addRowData() ;

      for (int j = 0 ; j < 10 ; j++) {
        dataset.addData(i, new XYNumberChartData(j, Math.random() * 100D)) ;
      }
    }

    return dataset ;
  }

}
