package demo.linecharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class XYSplineRendererDemo1 extends JPanel {

  private ChartOrientation horizontal = ChartOrientation.VERTICAL ;

  private IMatrixDataset dataset = createDataset1() ;

  public XYSplineRendererDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IJChart chart = ChartFactory.createXYLineAndShapeChart(
      "XYLineAndShapeRender", "X", "Y", dataset, horizontal, true, true, false, false) ;

    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    XYNumberValueAxis domainaxis = (XYNumberValueAxis) xyplot.getDomainAxis() ;
    domainaxis.setAxisRangeIncludeZero(false) ;
    domainaxis.setTickUnit(new LongTickUnit()) ;
    domainaxis.setLowerMargin(0.02) ;
    domainaxis.setUpperMargin(0.02) ;

    XYNumberValueAxis numberaxis = (XYNumberValueAxis) xyplot.getValueAxis() ;
    numberaxis.setAxisRangeIncludeZero(false) ;
    numberaxis.setTickUnit(new LongTickUnit()) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowKey("Series 2") ;

    dataset.addRowData(2) ;
    dataset.addData(0, new XYNumberChartData(2D, 56.270000000000003D)) ;
    dataset.addData(0, new XYNumberChartData(3D, 41.32D)) ;
    dataset.addData(0, new XYNumberChartData(4D, 31.449999999999999D)) ;
    dataset.addData(0, new XYNumberChartData(5D, 30.050000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(6D, 24.690000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(7D, 19.780000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(8D, 20.940000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(9D, 16.73D)) ;
    dataset.addData(0, new XYNumberChartData(10D, 14.210000000000001D)) ;
    dataset.addData(0, new XYNumberChartData(11D, 12.44D)) ;

    dataset.addData(1, new XYNumberChartData(11D, 56.270000000000003D)) ;
    dataset.addData(1, new XYNumberChartData(10D, 41.32D)) ;
    dataset.addData(1, new XYNumberChartData(9D, 31.449999999999999D)) ;
    dataset.addData(1, new XYNumberChartData(8D, 30.050000000000001D)) ;
    dataset.addData(1, new XYNumberChartData(7D, 24.690000000000001D)) ;
    dataset.addData(1, new XYNumberChartData(6D, 19.780000000000001D)) ;
    dataset.addData(1, new XYNumberChartData(5D, 20.940000000000001D)) ;
    dataset.addData(1, new XYNumberChartData(4D, 16.73D)) ;
    dataset.addData(1, new XYNumberChartData(3D, 14.210000000000001D)) ;
    dataset.addData(1, new XYNumberChartData(2D, 12.44D)) ;

    return dataset ;
  }

}
