package demo.miscellaneous ;

import java.awt.Color ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.plot.NoAxisPlot ;
import com.ijchart.xychart.render.noaxis.PolarRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class PolarChartDemo1 extends JPanel {

  public PolarChartDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    DefaultMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createPolarChart("Polar Chart Demo 1", dataset, true, true) ;
    NoAxisPlot plot = (NoAxisPlot) chart.getPlot() ;
    PolarRender render = (PolarRender) plot.getRender() ;
    render.setAngleGridlinePaint(Color.white) ;
    render.setRadiusGridlinePaint(Color.white) ;
    render.setBaseItemFill(false) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static DefaultMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowKey("Series 2") ;

    dataset.addRowData(2) ;
    dataset.addData(0, new XYNumberChartData(0.0D, 2D)) ;
    dataset.addData(0, new XYNumberChartData(90D, 13D)) ;
    dataset.addData(0, new XYNumberChartData(180D, 9D)) ;
    dataset.addData(0, new XYNumberChartData(270D, 8D)) ;

    dataset.addData(1, new XYNumberChartData(90D, -11.199999999999999D)) ;
    dataset.addData(1, new XYNumberChartData(180D, 21.399999999999999D)) ;
    dataset.addData(1, new XYNumberChartData(250D, 17.300000000000001D)) ;
    dataset.addData(1, new XYNumberChartData(355D, 10.9D)) ;

    return dataset ;
  }

}
