package demo.miscellaneous.markers ;

import java.awt.BasicStroke ;
import java.awt.BorderLayout ;
import java.awt.Color ;
import java.awt.Font ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.category.CategoryAxis ;
import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.HorizontalAlignment ;
import com.ijchart.xychart.constant.TextPosition ;
import com.ijchart.xychart.constant.VerticalAlignment ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.marker.CategoryMarker ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.LineAndShapeRender ;
import com.ijchart.xychart.ui.Layer ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class CategoryMarkerDemo1 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.VERTICAL ;

  public CategoryMarkerDemo1() {
    setLayout(new BorderLayout()) ;
    addPanel1() ;
  }

  private void addPanel1() {
    DefaultMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createCategoryLineAndShapeChart("Category Marker Demo 1",
                                                                 "Category", "Count", dataset,
                                                                 orientation, true, true) ;
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    LineAndShapeRender render = (LineAndShapeRender) plot.getRender() ;
    render.setBaseItemShapeFilled(true) ;
    render.setAutoSelectFillPaint(false) ;
    render.setBaseItemFillPaint(Color.white) ;
    render.setBaseItemLabelVisible(false) ;

    CategoryAxis xAxis = plot.getCategoryAxis() ;
    CategoryMarker marker = new CategoryMarker(dataset.getColKey(3), render.getBackgroundPaint(),
                                               Color.blue, new BasicStroke(1.0F), 0.0F) ;
    marker.setText("Marker Label") ;
    marker.setDrawBorder(true) ;
    marker.setDrawAsLine(true) ;
    marker.setTextFont(new Font("Dialog", 0, 11)) ;
    if (orientation.equals(ChartOrientation.VERTICAL)) {
      marker.setTextPosition(TextPosition.OUTSIDE_LEFT) ;
      marker.setTextVerticalAlign(VerticalAlignment.TOP) ;
      plot.setValueGridlinePaint(Color.white) ;
    } else {
      marker.setTextPosition(TextPosition.OUTSIDE_TOP) ;
      marker.setTextHorizontalAlign(HorizontalAlignment.LEFT) ;
      plot.setDomainGridlinePaint(Color.white) ;
    }
    xAxis.addCategoryMarker(Layer.BACKGROUND, marker) ;
    NumberValueAxis numberaxis = (NumberValueAxis) plot.getValueAxis() ;
    numberaxis.setUpperMargin(0.04999999999999999D) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static DefaultMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addColKey("Category 1") ;
    dataset.addColKey("Category 2") ;
    dataset.addColKey("Category 3") ;
    dataset.addColKey("Category 4") ;
    dataset.addColKey("Category 5") ;
    dataset.addRowData(1) ;

    dataset.addData(0, new NumberChartData(21D)) ;
    dataset.addData(0, new NumberChartData(50D)) ;
    dataset.addData(0, new NumberChartData(152D)) ;
    dataset.addData(0, new NumberChartData(184D)) ;
    dataset.addData(0, new NumberChartData(299D)) ;

    return dataset ;
  }

}
