package demo.others.categorycharts ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.StatisticalChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.format.StatisticalChartDataFormatter ;
import com.ijchart.xychart.label.DefaultLabelGenerator ;
import com.ijchart.xychart.label.ILabelGenerator ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.AbstractCategoryRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class StatisticalLineChartPanelWithLabelPanel extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public StatisticalLineChartPanelWithLabelPanel() {
//    setLayout(new GridLayout(1, 1)) ;
//    addPanel1() ;
//    addPanel2() ;
//    addPanel3() ;
//    addPanel4() ;

    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStaticalLineChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;
    setChartLabelMean(chart) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStaticalLineChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true) ;
    setChartLabelDeviation(chart) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStaticalLineChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;
    setChartLabelMeanDeviation(chart) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;
//        ((Bar2DRender) plot.getRender()).setBaseValue(200000) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {

    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createStaticalLineChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true) ;

    setChartLabelMean(chart) ;
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;
    valueAxis.setLowerMargin(0.05) ;
    valueAxis.setUpperMargin(0.1) ;
//        ((Bar2DRender) plot.getRender()).setBaseValue( -200000) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static void setChartLabelMean(IJChart chart) {
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractCategoryRender render = plot.getRender() ;
    StatisticalChartDataFormatter format =
      new StatisticalChartDataFormatter("#.#", "#.#",
                                        StatisticalChartDataFormatter.
                                        STATISTICAL_FORMATTER_TYPE_MEAN) ;
    ILabelGenerator labelGenerator = new DefaultLabelGenerator(format) ;
    render.setLabelGenerator(labelGenerator) ;
  }

  private static void setChartLabelDeviation(IJChart chart) {
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractCategoryRender render = plot.getRender() ;
    StatisticalChartDataFormatter format =
      new StatisticalChartDataFormatter("#.#", "#.#",
                                        StatisticalChartDataFormatter.
                                        STATISTICAL_FORMATTER_TYPE_DEVIATION) ;
    ILabelGenerator labelGenerator = new DefaultLabelGenerator(format) ;
    render.setLabelGenerator(labelGenerator) ;
  }

  private static void setChartLabelMeanDeviation(IJChart chart) {
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    AbstractCategoryRender render = plot.getRender() ;
    StatisticalChartDataFormatter format =
      new StatisticalChartDataFormatter("#.#", "#.#",
                                        StatisticalChartDataFormatter.
                                        STATISTICAL_FORMATTER_TYPE_MEAN_DEVIATION) ;
    ILabelGenerator labelGenerator = new DefaultLabelGenerator(format) ;
    render.setLabelGenerator(labelGenerator) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Col1") ;
    dataset.addColKey("Col2") ;
    dataset.addColKey("Col3") ;
    dataset.addColKey("Col4") ;

    dataset.addRowKey("Row1") ;
    dataset.addRowKey("Row2") ;

    dataset.addRowData() ;
    dataset.addData(0, new StatisticalChartData(10, 2)) ;
    dataset.addData(0, new StatisticalChartData(15, 4)) ;
    dataset.addData(0, new StatisticalChartData(13, 2)) ;
    dataset.addData(0, new StatisticalChartData(7, 1)) ;

    dataset.addRowData() ;
    dataset.addData(1, new StatisticalChartData(22, 2.4)) ;
    dataset.addData(1, new StatisticalChartData(18, 4.4)) ;
    dataset.addData(1, new StatisticalChartData(28, 2.1)) ;
    dataset.addData(1, new StatisticalChartData(17, 1.3)) ;

    return dataset ;
  }

}
