package demo.others.shapes ;

import java.awt.Color ;
import java.awt.Dimension ;
import java.awt.Graphics ;
import java.awt.Graphics2D ;
import java.awt.GridLayout ;
import java.awt.RenderingHints ;
import java.awt.event.MouseEvent ;
import java.awt.event.MouseMotionAdapter ;
import java.awt.geom.Line2D ;
import java.awt.geom.Point2D ;
import java.awt.geom.Rectangle2D ;
import java.util.HashMap ;
import java.util.Map ;

import javax.swing.BorderFactory ;
import javax.swing.JLabel ;
import javax.swing.JPanel ;

import com.ijchart.xychart.constant.HorizontalAlignment ;
import com.ijchart.xychart.constant.VerticalAlignment ;
import com.ijchart.xychart.shape.HighLowChartShape ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class HighLowChartShapePanel extends JPanel {
  private Map hashMap = new HashMap() ;

  private JLabel label ;

  public HighLowChartShapePanel() {
    init() ;
  }

  private void init() {
    hashMap.put(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON) ;

    setLayout(new GridLayout(2, 3)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;

    label = new JLabel("begin") ;
    add(label) ;
  }

  private void addPanel1() {
    Line2D highLowLine = new Line2D.Double(20, 20, 20, 50) ;
    Line2D openLine = new Line2D.Double(15, 40, 20, 40) ;
    Line2D closeLine = new Line2D.Double(20, 30, 25, 30) ;

    Rectangle2D drawArea = new Rectangle2D.Double(15, 20, 10, 40) ;

    final HighLowChartShape shape = new HighLowChartShape(drawArea, "abc", highLowLine, Color.red,
                                                          openLine, Color.red, closeLine, Color.red) ;
    shape.setForceInsideTextNoWrap(true) ;
    shape.setTextHorizontalAlign(HorizontalAlignment.CENTER) ;
    shape.setTextVerticalAlign(VerticalAlignment.CENTER) ;
//    shape.setRotate(Math.PI / 4) ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.draw((Graphics2D) g) ;

        Point2D p = shape.getLockPoint() ;
        g.setColor(Color.blue) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }
    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(160, 160)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel2() {
    final Line2D highLowLine = null ;
    Line2D openLine = new Line2D.Double(15, 40, 20, 40) ;
    Line2D closeLine = new Line2D.Double(20, 30, 25, 30) ;

    Rectangle2D drawArea = new Rectangle2D.Double(15, 20, 10, 40) ;

    final HighLowChartShape shape = new HighLowChartShape(drawArea, "abc", highLowLine, Color.red,
                                                          openLine, Color.red, closeLine, Color.red) ;
    shape.setForceInsideTextNoWrap(true) ;
    shape.setTextHorizontalAlign(HorizontalAlignment.CENTER) ;
    shape.setTextVerticalAlign(VerticalAlignment.CENTER) ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.draw((Graphics2D) g) ;

        Point2D p = shape.getLockPoint() ;
        g.setColor(Color.blue) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }
    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(160, 160)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel3() {
    Line2D highLowLine = new Line2D.Double(20, 20, 20, 60) ;
    final Line2D openLine = null ;
    Line2D closeLine = new Line2D.Double(20, 30, 30, 30) ;

    Rectangle2D drawArea = new Rectangle2D.Double(15, 20, 10, 40) ;

    final HighLowChartShape shape = new HighLowChartShape(drawArea, "abc", highLowLine, Color.red,
                                                          openLine, Color.red, closeLine, Color.red) ;
    shape.setForceInsideTextNoWrap(true) ;
    shape.setTextHorizontalAlign(HorizontalAlignment.CENTER) ;
    shape.setTextVerticalAlign(VerticalAlignment.CENTER) ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.draw((Graphics2D) g) ;

        Point2D p = shape.getLockPoint() ;
        g.setColor(Color.blue) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }
    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(160, 160)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

  private void addPanel4() {
    Line2D highLowLine = new Line2D.Double(20, 20, 20, 50) ;
    Line2D openLine = new Line2D.Double(15, 40, 20, 40) ;
    Line2D closeLine = new Line2D.Double(20, 30, 25, 30) ;

    Rectangle2D drawArea = new Rectangle2D.Double(15, 20, 10, 40) ;

    final HighLowChartShape shape = new HighLowChartShape(drawArea, "abc", highLowLine, Color.red,
                                                          openLine, Color.red, closeLine, Color.red) ;
    shape.setForceInsideTextNoWrap(true) ;
    shape.setTextHorizontalAlign(HorizontalAlignment.CENTER) ;
    shape.setTextVerticalAlign(VerticalAlignment.CENTER) ;

    JPanel panel = new JPanel() {
      public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g ;
        g2.addRenderingHints(hashMap) ;

        setBackground(Color.white) ;
        super.paintComponent(g) ;

        shape.draw((Graphics2D) g) ;

        Point2D p = shape.getLockPoint() ;
        g.setColor(Color.blue) ;
        g.fillRect((int) p.getX(), (int) p.getY(), 2, 2) ;
      }
    } ;

    panel.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        label.setText("(" + e.getX() + "," + e.getY() + ")" + shape.contains(e.getX(), e.getY())) ;
      }
    }) ;

    panel.setPreferredSize(new Dimension(160, 160)) ;
    panel.setBorder(BorderFactory.createLineBorder(Color.red)) ;
    add(panel) ;
  }

}
