package demo.others.xy ;

import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.IntervalXNumberYBaseChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.format.IntervalXNumberYBaseChartDataFormatter ;
import com.ijchart.xychart.label.DefaultLabelGenerator ;
import com.ijchart.xychart.label.ILabelGenerator ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.AbstractXYRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class IntervalXNumberYBaseBar2DChartPanel2 extends JPanel {

  private ChartOrientation vertical = ChartOrientation.VERTICAL ;

  private ChartOrientation horizontal = ChartOrientation.HORIZONTAL ;

  public IntervalXNumberYBaseBar2DChartPanel2() {
//    setLayout(new GridLayout(1, 1)) ;
//    addPanel1() ;
//    addPanel2() ;
//    addPanel3() ;
//    addPanel4() ;

    setLayout(new GridLayout(2, 2)) ;
    addPanel1() ;
    addPanel2() ;
    addPanel3() ;
    addPanel4() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createIntervalXBaseYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, false, false) ;

    setChartLabelXY(chart) ;
//        XYPlot plot = (XYPlot) chart.getPlot() ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(2.0F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(2.0F)) ;
//        xyRender.setBaseItemLabelFont(new Font("Dialog", 1, 14)) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel2() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createIntervalXBaseYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, vertical, true, true, false, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(2.0F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(2.0F)) ;
//        xyRender.setBaseItemLabelFont(new Font("Dialog", 1, 14)) ;
//
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;
//        valueAxis.setLowerMargin(0.05) ;
//        valueAxis.setUpperMargin(0.05) ;
    setChartLabelXY(chart) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel3() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createIntervalXBaseYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true, false, false) ;

    setChartLabelXY(chart) ;
//        XYPlot plot = (XYPlot) chart.getPlot() ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(1.5F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(2.5F)) ;
//
//        AbstractValueAxis valueAxis = plot.getValueAxis() ;
//        valueAxis.setLowerMargin(0.05) ;
//        valueAxis.setUpperMargin(0.05) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private void addPanel4() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createIntervalXBaseYBar2DChart(
      "This is a very long title,it has many words and wrap automatically.", "x axis text",
      "y axis text", dataset, horizontal, true, true, false, false) ;

    setChartLabelXY(chart) ;
    XYPlot plot = (XYPlot) chart.getPlot() ;
//        AbstractXYRender xyRender = plot.getRender() ;
//        xyRender.setRowItemsOutlineStroke(0, new BasicStroke(1.0F)) ;
//        xyRender.setRowItemsOutlineStroke(1, new BasicStroke(4.0F)) ;
//
    AbstractValueAxis valueAxis = plot.getValueAxis() ;
    valueAxis.setInverted(true) ;
//        valueAxis.setLowerMargin(0.05) ;
//        valueAxis.setUpperMargin(0.05) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static void setChartLabelXY(IJChart chart) {
    XYPlot plot = (XYPlot) chart.getPlot() ;
    AbstractXYRender render = plot.getRender() ;
    IntervalXNumberYBaseChartDataFormatter format =
      new IntervalXNumberYBaseChartDataFormatter("#.#", "#.#", "#.#") ;
    ILabelGenerator labelGenerator = new DefaultLabelGenerator(format) ;

    render.setLabelGenerator(labelGenerator) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Col1") ;
    dataset.addColKey("Col2") ;
    dataset.addColKey("Col3") ;
    dataset.addColKey("Col4") ;

    dataset.addRowKey("Row1") ;
    dataset.addRowKey("Row2") ;

    dataset.addRowData() ;
    dataset.addData(0, new IntervalXNumberYBaseChartData(1.0D, 3D, 5)) ;
    dataset.addData(0, new IntervalXNumberYBaseChartData(4D, 5D, 8)) ;
    dataset.addData(0, new IntervalXNumberYBaseChartData(7D, 9D, 9)) ;
    dataset.addData(0, new IntervalXNumberYBaseChartData(12D, 15D, 20)) ;

    dataset.addRowData() ;
    dataset.addData(1, new IntervalXNumberYBaseChartData(18.0D, 30D, 3)) ;
    dataset.addData(1, new IntervalXNumberYBaseChartData(40D, 50D, 1)) ;
    dataset.addData(1, new IntervalXNumberYBaseChartData(70D, 90D, 25)) ;
    dataset.addData(1, new IntervalXNumberYBaseChartData(120D, 150D, 18)) ;

    return dataset ;
  }

}
