package demo.overlaidcharts ;

import java.awt.BasicStroke ;
import java.awt.Color ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.TextPosition ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.format.NumberChartDataFormatter ;
import com.ijchart.xychart.label.DefaultLabelGenerator ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.Bar2DRender ;
import com.ijchart.xychart.render.category.LevelRender ;
import com.ijchart.xychart.tickunit.LongTickUnit ;
import com.ijchart.xychart.ui.RectangleEdge ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class OverlaidBarChartDemo2 extends JPanel {

  public OverlaidBarChartDemo2() {
    setLayout(new GridLayout(1, 1)) ;
    createPanel1() ;
  }

  public void createPanel1() {
    IJChart chart = createChart() ;
    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IJChart createChart() {
    IMatrixDataset dataset1 = createDataset1() ;
    IJChart chart = ChartFactory.createCategoryBar2DChart("Overlaid Bar Chart2", "Category",
                                                          "Value", dataset1,
                                                          ChartOrientation.VERTICAL, true, true) ;
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.setDomainGridlinePaint(Color.white) ;
    plot.setValueGridlinePaint(Color.white) ;

    NumberValueAxis valueAxis = (NumberValueAxis) plot.getValueAxis() ;
    valueAxis.setUpperMargin(0.02) ;
    valueAxis.setTickUnit(new LongTickUnit()) ;

    Bar2DRender render = (Bar2DRender) plot.getRender() ;
    render.setLabelGenerator(new DefaultLabelGenerator(new NumberChartDataFormatter("#0"))) ;
    render.setBaseItemLabelVisible(true) ;
    render.setBaseItemLabelPosition(TextPosition.OUTSIDE_TOP) ;

    IMatrixDataset dataset2 = createDataset2() ;
//    NumberValueAxis valueAxis2 = new NumberValueAxis(dataset2) ;
//    valueAxis2.setUpperMargin(0.05) ;
//    plot.setValueAxis(1, valueAxis2) ;

    LevelRender render2 = new LevelRender(dataset2) ;
    render2.setAutoSelectBorderStroke(false) ;
    render2.setBaseItemBorderStroke(new BasicStroke(2.0F)) ;
    render2.setLabelGenerator(new DefaultLabelGenerator(new NumberChartDataFormatter("#0"))) ;
    render2.setBaseItemLabelVisible(true) ;
    render2.setBaseItemLabelPosition(TextPosition.OUTSIDE_TOP) ;

    plot.setRender(1, render2) ;
    chart.getLegendTitle().setPosition(RectangleEdge.RIGHT) ;

    return chart ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;

    double[][] data = new double[][] { {1.0D, 4D, 3D, 5D, 5D}, {5D, 7D, 6D, 8D, 4D}
    } ;
    dataset.addColKey("S1") ;
    dataset.addColKey("S2") ;

    for (int i = 0 ; i < 5 ; i++) {
      dataset.addRowData() ;
      dataset.addRowKey("Category " + (i + 1)) ;
      dataset.addData(i, new NumberChartData(data[0][i])) ;
      dataset.addData(i, new NumberChartData(data[1][i])) ;
    }

    return dataset ;
  }

  private static IMatrixDataset createDataset2() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    double[][] data = new double[][] { {6D, 7D, 2D, 6D, 6D}, {4D, 2D, 1D, 3D, 2D}
    } ;
    dataset.addColKey("Prior 1") ;
    dataset.addColKey("Prior 2") ;

    for (int i = 0 ; i < 5 ; i++) {
      dataset.addRowData() ;
      dataset.addRowKey("Category " + (i + 1)) ;
      dataset.addData(i, new NumberChartData(data[0][i])) ;
      dataset.addData(i, new NumberChartData(data[1][i])) ;
    }

    return dataset ;
  }
}
