package com.ijchart.xychart.constant ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ǩ.</zh>
 * <en>Defines tokens used to indicate a axis label type.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class AxisLabelType implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 4287187582555083343L ;

  /**
   * <zh>.</zh>
   * <en>Row.</en>
   */
  public static final AxisLabelType ROW = new AxisLabelType("AxisLabelType.ROW") ;

  /**
   * <zh>.</zh>
   * <en>Column.</en>
   */
  public static final AxisLabelType COLUMN = new AxisLabelType("AxisLabelType.COLUMN") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   * @param name <zh>.</zh>
   * <en>The name.</en>
   */
  private AxisLabelType(String name) {
    this.name = name ;
  }

  /**
   * <zh>¼.</zh>
   * <en>Returns a string representing the object.</en>
   *
   * @return <zh>¼.</zh>
   * <en>The string.</en>
   */
  public String toString() {
    return this.name ;
  }

  /**
   * <zh>ʵǷ.</zh>
   * <en>Returns true if this object is equal to the specified object, and false otherwise.</en>
   *
   * @param obj <zh>ҪȽϵĶ (Ϊnull).</zh>
   * <en>The object (null permitted).</en>
   *
   * @return A boolean.
   */
  public boolean equals(Object obj) {
    if (this == obj) {
      return true ;
    }
    if (!(obj instanceof AxisLabelType)) {
      return false ;
    }

    AxisLabelType that = (AxisLabelType) obj ;
    return this.name.equals(that.name) ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object.</en>
   *
   * @return <zh>hascodeֵ.</zh>
   * <en>The hashcode.</en>
   */
  public int hashCode() {
    return this.name.hashCode() ;
  }
}
