package com.ijchart.xychart.constant ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ֱͼ.</zh>
 * <en>Used to describe the type of histogram</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class HistogramType implements Serializable {

  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization</en>
   */
  private static final long serialVersionUID = -7847946234099817714L ;

  /**
   * <zh>Ƶ͵ֱͼ.</zh>
   * <en>The frequency histogram chart.</en>
   */
  public static final HistogramType FREQUENCY = new HistogramType("HistogramType.FREQUENCY") ;

  /**
   * <zh>ֵ͵ֱͼ.</zh>
   * <en>The relative histogram chart.</en>
   */
  public static final HistogramType RELATIVE_FREQUENCY = new HistogramType(
    "HistogramType.RELATIVE_FREQUENCY") ;

  /**
   * <zh>ʾСΪ1ֱͼ.</zh>
   * <en>The scale area to one histogram chart.</en>
   */
  public static final HistogramType SCALE_AREA_TO_1 = new HistogramType(
    "HistogramType.SCALE_AREA_TO_1") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param name String <zh>.</zh>
   * <en>The name.</en>
   */
  private HistogramType(String name) {
    this.name = name ;
  }

  /**
   * <zh></zh>
   * <en>Returns a string representing the object.</en>
   * @return The string.
   */
  public String toString() {
    return this.name ;
  }

  /**
   * <zh>Ƿ.</zh>
   * <en>Returns true if this object is equal to the specified object, and false otherwise.</en>
   *
   * @param o  the other object.
   * @return A boolean.
   */
  public boolean equals(Object o) {
    if (this == o) {
      return true ;
    }
    if (!(o instanceof HistogramType)) {
      return false ;
    }

    HistogramType that = (HistogramType) o ;
    if (!this.name.equals(that.name)) {
      return false ;
    }

    return true ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object</en>
   *
   * @return int <zh>hashcodeֵ.</zh>
   * <en>A hash code value for this object.</en>
   */
  public int hashCode() {
    return name.hashCode() ;
  }

}
