package com.ijchart.xychart.constant ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>{@link com.ijchart.xychart.dataset.data.KeyValuePair},ֵ.</zh>
 * <en>Define the type of sort {@link com.ijchart.xychart.dataset.data.KeyValuePair} object,
 * key or value.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class KeyValueComparatorType implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = -7360669040265769747L ;

  /**
   * <zh>{@link com.ijchart.xychart.dataset.data.KeyValuePair}ļ.</zh>
   * <en>Sort {@link com.ijchart.xychart.dataset.data.KeyValuePair} object by key.</en>
   */
  public static final KeyValueComparatorType BY_KEY = new KeyValueComparatorType(
    "KeyValueComparatorType.BY_KEY") ;

  /**
   * <zh>{@link com.ijchart.xychart.dataset.data.KeyValuePair}ֵ.</zh>
   * <en>Sort {@link com.ijchart.xychart.dataset.data.KeyValuePair} object by value.</en>
   */
  public static final KeyValueComparatorType BY_VALUE = new KeyValueComparatorType(
    "KeyValueComparatorType.BY_VALUE") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param name <zh>.</zh>
   * <en>The name.</en>
   */
  private KeyValueComparatorType(String name) {
    this.name = name ;
  }

  /**
   * <zh>equals.</zh>
   * <en>Override equals method.</en>
   * @param obj Object
   * @return boolean
   */
  public boolean equals(Object obj) {
    if (this == obj) {
      return true ;
    }

    if (!(obj instanceof KeyValueComparatorType)) {
      return false ;
    }

    KeyValueComparatorType tmp = (KeyValueComparatorType) obj ;

    return this.name.equals(tmp.name) ;
  }

  /**
   * <zh>toString().</zh>
   * <en>Override toString method.</en>
   * @return String
   */
  public String toString() {
    return "[name=" + name + "]" ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object. </en>
   * @return  a hash code value for this object.
   */
  public int hashCode() {
    return (this.name == null) ? 0 : this.name.hashCode() ;
  }

}
