package com.ijchart.xychart.event ;

import java.io.Serializable ;
import java.util.EventObject ;

import com.ijchart.xychart.title.ITitle ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>title仯¼.</zh>
 * <en>A change event that encapsulates information about a change to a title.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class TitleChangeEvent extends EventObject implements Serializable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = -3965279511911370930L ;

  /**
   * <zh>¼title.</zh>
   * <en>The title that generated the change event.</en>
   */
  private ITitle title ;

  /**
   * <zh>һµĶ.</zh>
   * <en>Creates a new instance.</en>
   *
   * @param title ITitle <zh>¼title (Ϊnull).</zh>
   * <en>The title that generated the event (null not permitted).</en>
   */
  public TitleChangeEvent(ITitle title) {
    super(title) ;
    this.title = title ;
  }

  /**
   * <zh>ز¼title.</zh>
   * <en>Returns the title that generated the event.</en>
   *
   * @return <zh>¼title.</zh>
   * <en>The title that generated the event.</en>
   */
  public ITitle getTitle() {
    return this.title ;
  }

}
