package com.ijchart.xychart.plot ;

import java.awt.geom.Point2D ;
import java.awt.geom.Rectangle2D ;

import com.ijchart.xychart.constant.ChartOrientation ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>plotҪ,Ӧʵִ˽ӿ.</zh>
 * <en>A plot that is zoomable must implement this interface to provide a
 * mechanism for the {@link com.ijchart.xychart.client.ChartPanel} to control the zooming.</en>
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public interface IZoomable {

  /**
   * <zh>domainǷ.</zh>
   * <en>Returns true if the plot's domain axis is zoomable, and false otherwise.</en>
   *
   * @return boolean <zh>ֵ.</zh>
   * <en>A boolean.</en>
   */
  boolean isDomainZoomable() ;

  /**
   * <zh>valueǷ.</zh>
   * <en>Returns true if the plot's value is zoomable, and false otherwise.</en>
   *
   * @return boolean <zh>ֵ.</zh>
   * <en>A boolean.</en>
   */
  boolean isValueZoomable() ;

  /**
   * <zh>chartķ.</zh>
   * <en>Returns the orientation of the plot.</en>
   *
   * @return ChartOrientation <zh>chartĻƷ.</zh>
   * <en>The orientation.</en>
   */
  ChartOrientation getOrientation() ;

  /**
   * <zh>domain.</zh>
   * <en>Zoom domain axes.</en>
   *
   * @param selectArea Rectangle2D <zh>ѡ,Ϊnullʾָǰ״̬.</zh>
   * <en>The selected area,null to restore chart.</en>
   * @param dataArea Rectangle2D <zh>,Ϊnullʾָǰ״̬.</zh>
   * <en>The data area,null to restore chart.</en>
   * @param source Point2D <zh>Դ (Ϊnull).</zh>
   * <en>The source mouse point (null not permitted).</en>
   */
  void zoomDomainAxes(Rectangle2D selectArea, Rectangle2D dataArea, Point2D source) ;

  /**
   * <zh>value.</zh>
   * <en>Zoom value axes.</en>
   *
   * @param selectArea Rectangle2D <zh>ѡ,Ϊnullʾָǰ״̬.</zh>
   * <en>The selected area,null to restore chart.</en>
   * @param dataArea Rectangle2D <zh>,Ϊnullʾָǰ״̬.</zh>
   * <en>The data area,null to restore chart.</en>
   * @param source Point2D <zh>Դ (Ϊnull).</zh>
   * <en>The source mouse point (null not permitted).</en>
   */
  void zoomValueAxes(Rectangle2D selectArea, Rectangle2D dataArea, Point2D source) ;

}
