package com.ijchart.xychart.util ;

import java.util.Calendar ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ڵĹ.</zh>
 * <en>Nice static helpers for working with Date.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public abstract class DateUtil {

  /**
   * <zh>ֵ֮.</zh>
   * <en>Calculate seconds between tow date.</en>
   *
   * @param startDateMills long <zh>ʼ,λΪ.</zh>
   * <en>The start date,in millisecond.</en>
   * @param endDateMills long <zh>,λΪ.</zh>
   * <en>The end date,in millisecond.</en>
   *
   * @return long <zh>Ϊλʱ.</zh>
   * <en>The time difference,in seconds.</en>
   */
  public static long getSecondsBetween(long startDateMills, long endDateMills) {
    if (startDateMills == endDateMills) {
      return 1 ;
    }

    long min = Math.min(startDateMills, endDateMills) ;
    long max = Math.max(startDateMills, endDateMills) ;

    final int second = 1000 ;
    long minSeconds = min / second ; //ʼʱ,λ
    long maxSeconds = max / second ; //ʱ,λ
    long maxMills = max % second ; //ʱĺ벿

    return maxSeconds - minSeconds + ((maxMills > 0) ? 1 : 0) ;
  }

  /**
   * <zh>ֵ֮ķ.</zh>
   * <en>Calculate minutes between tow date.</en>
   *
   * @param startDateMills long <zh>ʼ,λΪ.</zh>
   * <en>The start date,in millisecond.</en>
   * @param endDateMills long <zh>,λΪ.</zh>
   * <en>The end date,in millisecond.</en>
   *
   * @return long <zh>ԷΪλʱ.</zh>
   * <en>The time difference,in minutes.</en>
   */
  public static long getMinutesBetween(long startDateMills, long endDateMills) {
    if (startDateMills == endDateMills) {
      return 1 ;
    }

    long min = Math.min(startDateMills, endDateMills) ;
    long max = Math.max(startDateMills, endDateMills) ;

    final int minute = 60 * 1000 ;
    long minMinutes = min / minute ; //ʼʱ,λ
    long maxMinutes = max / minute ; //ʱ,λ
    long maxMills = max % minute ; //ʱĺ벿

    return maxMinutes - minMinutes + ((maxMills > 0) ? 1 : 0) ;
  }

  /**
   * <zh>ֵ֮Сʱ.</zh>
   * <en>Calculate hours between tow date.</en>
   *
   * @param startDateMills long <zh>ʼ,λΪ.</zh>
   * <en>The start date,in millisecond.</en>
   * @param endDateMills long <zh>,λΪ.</zh>
   * <en>The end date,in millisecond.</en>
   *
   * @return long <zh>СʱΪλʱ.</zh>
   * <en>The time difference,in hours.</en>
   */
  public static long getHoursBetween(long startDateMills, long endDateMills) {
    if (startDateMills == endDateMills) {
      return 1 ;
    }

    long min = Math.min(startDateMills, endDateMills) ;
    long max = Math.max(startDateMills, endDateMills) ;

    final int hour = 60 * 60 * 1000 ;
    long minHours = min / hour ; //ʼʱ,λ
    long maxHours = max / hour ; //ʱ,λ
    long maxMills = max % hour ; //ʱĺ벿

    return maxHours - minHours + ((maxMills > 0) ? 1 : 0) ;
  }

  /**
   * <zh>ֵ֮.</zh>
   * <en>Calculate days between tow date.</en>
   *
   * @param startDateMills long <zh>ʼ,λΪ.</zh>
   * <en>The start date,in millisecond.</en>
   * @param endDateMills long <zh>,λΪ.</zh>
   * <en>The end date,in millisecond.</en>
   *
   * @return long <zh>Ϊλʱ.</zh>
   * <en>The time difference,in days.</en>
   */
  public static long getDaysBetween(long startDateMills, long endDateMills) {
    if (startDateMills == endDateMills) {
      return 1 ;
    }

    long min = Math.min(startDateMills, endDateMills) ;
    long max = Math.max(startDateMills, endDateMills) ;

    final int day = 24 * 60 * 60 * 1000 ;
    final int eightHours = 8 * 60 * 60 * 1000 ; //׼ʱΪ1970.1.1 8:00
    min += eightHours ;
    max += eightHours ;

    long minDays = min / day ; //ʼʱ,λ
    long maxDays = max / day ; //ʱ,λ
    long maxMills = max % day ; //ʱĺ벿

    return maxDays - minDays + ((maxMills > 0) ? 1 : 0) ;
  }

  /**
   * <zh>ֵ֮.</zh>
   * <en>Calculate months between tow date.</en>
   *
   * @param startDateMills long <zh>ʼ,λΪ.</zh>
   * <en>The start date,in millisecond.</en>
   * @param endDateMills long <zh>,λΪ.</zh>
   * <en>The end date,in millisecond.</en>
   *
   * @return long <zh>Ϊλʱ.</zh>
   * <en>The time difference,in months.</en>
   */
  public static long getMonthsBetween(long startDateMills, long endDateMills) {
    if (startDateMills == endDateMills) {
      return 1 ;
    }

    long min = Math.min(startDateMills, endDateMills) ;
    long max = Math.max(startDateMills, endDateMills) ;

    //ʼʱ
    Calendar minCalendar = Calendar.getInstance() ;
    minCalendar.setTimeInMillis(min) ;
    int minYear = minCalendar.get(Calendar.YEAR) ;
    int minMonth = minCalendar.get(Calendar.MONTH) + 1 ;

    //ʱ
    Calendar maxCalendar = Calendar.getInstance() ;
    maxCalendar.setTimeInMillis(max) ;
    int maxYear = maxCalendar.get(Calendar.YEAR) ;
    int maxMonth = maxCalendar.get(Calendar.MONTH) + 1 ;

    return (12 - minMonth + 1) + (maxYear - minYear - 1) * 12 + maxMonth ;
  }

  /**
   * <zh>ֵ֮.</zh>
   * <en>Calculate years between tow date.</en>
   *
   * @param startDateMills long <zh>ʼ,λΪ.</zh>
   * <en>The start date,in millisecond.</en>
   * @param endDateMills long <zh>,λΪ.</zh>
   * <en>The end date,in millisecond.</en>
   *
   * @return long <zh>Ϊλʱ.</zh>
   * <en>The time difference,in years.</en>
   */
  public static long getYearsBetween(long startDateMills, long endDateMills) {
    if (startDateMills == endDateMills) {
      return 1 ;
    }

    long min = Math.min(startDateMills, endDateMills) ;
    long max = Math.max(startDateMills, endDateMills) ;

    //ʼʱ
    Calendar minCalendar = Calendar.getInstance() ;
    minCalendar.setTimeInMillis(min) ;
    int minYear = minCalendar.get(Calendar.YEAR) ;

    //ʱ
    Calendar maxCalendar = Calendar.getInstance() ;
    maxCalendar.setTimeInMillis(max) ;
    int maxYear = maxCalendar.get(Calendar.YEAR) ;

    return maxYear - minYear + 1 ;
  }

  /**
   * <zh>ʱתΪ.</zh>
   * <en>Convert a date to milliseconds.</en>
   *
   * @param year int <zh>.</zh>
   * <en>A year.</en>
   *
   * @return long <zh>ָʱĺ.</zh>
   * <en>The time as UTC milliseconds from the epoch..</en>
   */
  public static long dateToTimeInMillis(int year) {
    return dateToTimeInMillis(year, 1, 1, 0, 0, 0, 0) ;
  }

  /**
   * <zh>ʱתΪ.</zh>
   * <en>Convert a date to milliseconds.</en>
   *
   * @param year int <zh>.</zh>
   * <en>A year.</en>
   * @param month int <zh>,1ʾһ.</zh>
   * <en>A month,1 for January.</en>
   *
   * @return long <zh>ָʱĺ.</zh>
   * <en>The time as UTC milliseconds from the epoch..</en>
   */
  public static long dateToTimeInMillis(int year, int month) {
    return dateToTimeInMillis(year, month, 1, 0, 0, 0, 0) ;
  }

  /**
   * <zh>ʱתΪ.</zh>
   * <en>Convert a date to milliseconds.</en>
   *
   * @param year int <zh>.</zh>
   * <en>A year.</en>
   * @param month int <zh>,1ʾһ.</zh>
   * <en>A month,1 for January.</en>
   * @param day int <zh>.</zh>
   * <en>A day.</en>
   *
   * @return long <zh>ָʱĺ.</zh>
   * <en>The time as UTC milliseconds from the epoch..</en>
   */
  public static long dateToTimeInMillis(int year, int month, int day) {
    return dateToTimeInMillis(year, month, day, 0, 0, 0, 0) ;
  }

  /**
   * <zh>ʱתΪ.</zh>
   * <en>Convert a date to milliseconds.</en>
   *
   * @param year int <zh>.</zh>
   * <en>A year.</en>
   * @param month int <zh>,1ʾһ.</zh>
   * <en>A month,1 for January.</en>
   * @param day int <zh>.</zh>
   * <en>A day.</en>
   * @param hour int <zh>Сʱ.</zh>
   * <en>A hour.</en>
   *
   * @return long <zh>ָʱĺ.</zh>
   * <en>The time as UTC milliseconds from the epoch..</en>
   */
  public static long dateToTimeInMillis(int year, int month, int day, int hour) {
    return dateToTimeInMillis(year, month, day, hour, 0, 0, 0) ;
  }

  /**
   * <zh>ʱתΪ.</zh>
   * <en>Convert a date to milliseconds.</en>
   *
   * @param year int <zh>.</zh>
   * <en>A year.</en>
   * @param month int <zh>,1ʾһ.</zh>
   * <en>A month,1 for January.</en>
   * @param day int <zh>.</zh>
   * <en>A day.</en>
   * @param hour int <zh>Сʱ.</zh>
   * <en>A hour.</en>
   * @param minute int <zh>.</zh>
   * <en>A minute.</en>
   *
   * @return long <zh>ָʱĺ.</zh>
   * <en>The time as UTC milliseconds from the epoch..</en>
   */
  public static long dateToTimeInMillis(int year, int month, int day, int hour, int minute) {
    return dateToTimeInMillis(year, month, day, hour, minute, 0, 0) ;
  }

  /**
   * <zh>ʱתΪ.</zh>
   * <en>Convert a date to milliseconds.</en>
   *
   * @param year int <zh>.</zh>
   * <en>A year.</en>
   * @param month int <zh>,1ʾһ.</zh>
   * <en>A month,1 for January.</en>
   * @param day int <zh>.</zh>
   * <en>A day.</en>
   * @param hour int <zh>Сʱ.</zh>
   * <en>A hour.</en>
   * @param minute int <zh>.</zh>
   * <en>A minute.</en>
   * @param second int <zh>.</zh>
   * <en>A second.</en>
   *
   * @return long <zh>ָʱĺ.</zh>
   * <en>The time as UTC milliseconds from the epoch..</en>
   */
  public static long dateToTimeInMillis(int year, int month, int day,
                                        int hour, int minute, int second) {
    return dateToTimeInMillis(year, month, day, hour, minute, second, 0) ;
  }

  /**
   * <zh>ʱתΪ.</zh>
   * <en>Convert a date to milliseconds.</en>
   *
   * @param year int <zh>.</zh>
   * <en>A year.</en>
   * @param month int <zh>,1ʾһ.</zh>
   * <en>A month,1 for January.</en>
   * @param day int <zh>.</zh>
   * <en>A day.</en>
   * @param hour int <zh>Сʱ.</zh>
   * <en>A hour.</en>
   * @param minute int <zh>.</zh>
   * <en>A minute.</en>
   * @param second int <zh>.</zh>
   * <en>A second.</en>
   * @param millisecond int <zh>.</zh>
   * <en>A millisecond.</en>
   *
   * @return long <zh>ָʱĺ.</zh>
   * <en>The time as UTC milliseconds from the epoch..</en>
   */
  public static long dateToTimeInMillis(int year, int month, int day, int hour, int minute,
                                        int second, int millisecond) {
    Calendar cal = Calendar.getInstance() ;
    cal.set(year, month - 1, day, hour, minute, second) ;
    cal.set(Calendar.MILLISECOND, millisecond) ;

    return cal.getTimeInMillis() ;
  }
}
